import {
  StartServer,
  createHandler,
  renderAsync,
  renderStream,
} from "solid-start/entry-server";
import { refreshAuthToken } from "./server/auth";
import { createRefreshMiddleware } from "./util/refreshy";
import { createRC } from "./util";

(await import("dotenv")).config({ override: true });

export default createHandler(
  createRefreshMiddleware((req, resHeaders) =>
    refreshAuthToken(createRC(req, resHeaders))
  ),
  renderAsync((context) => <StartServer context={context} />)
);
