// @refresh reload
import { Suspense } from "solid-js";
import { Links, Meta, Routes, Scripts } from "solid-start/root";
import { ErrorBoundary } from "solid-start/error-boundary";
import "./index.css";
import { RefreshFunction, RefreshyProvider } from "./util/refreshy";
import { serveRefreshAuthToken } from "./server/auth";

const refresh: RefreshFunction = async () => {
  console.log("refresh jwt");
  await serveRefreshAuthToken();

  return Math.round(Math.random() * 1000);
};

export default function Root() {
  return (
    <html lang="en">
      <head>
        <meta charset="utf-8" />
        <meta name="viewport" content="width=device-width, initial-scale=1" />
        <Meta />
        <Links />
      </head>
      <body class="antialiased">
        <ErrorBoundary>
          <Suspense fallback={<div class="w-96 mx-auto my-5">fetching</div>}>
            <RefreshyProvider ttl={5} refresh={refresh}>
              <Routes />
            </RefreshyProvider>
          </Suspense>
        </ErrorBoundary>
        <Scripts />
      </body>
    </html>
  );
}
