import { useRouteData } from "solid-app-router";
import { createResource } from "solid-js";
import { authData } from "~/server/auth";
import { serveJwtData } from "~/server/jwtData";
import { composeRouteData } from "~/util";
import { useRefreshy } from "~/util/refreshy";

export const routeData = () => {
  const [refreshy, refreshData] = useRefreshy();

  const gety = refreshy((name) => serveJwtData(name));

  return composeRouteData({
    // TODO: Fix the redirect, it only works with ssr
    auth: authData({ redirectNoAuth: "/login" }),
    john: () => createResource(() => gety("john " + refreshData())),
    klaus: () => createResource(() => gety("klaus " + refreshData())),
    marry: () => createResource(() => gety("marry " + refreshData())),
  })();
};

export default () => {
  const [data, refetch, repos] = useRouteData() as any;

  return (
    <div class="mx-auto w-96 my-11">
      <button
        type="button"
        class="btn mb-6"
        onClick={() => {
          repos.john[1].refetch();
          repos.klaus[1].refetch();
          repos.marry[1].refetch();
        }}
      >
        Refetch
      </button>
      <div>{data.john}</div>
      <div>{data.klaus}</div>
      <div>{data.marry}</div>
    </div>
  );
};
