import server from "solid-start/server";
import { composeRouteData, useServer, withRC } from "~/util";
import { authData, login } from "~/server/auth";
import { useNavigate } from "solid-app-router";

export const routeData = composeRouteData({
  auth: authData({ redirectWithAuth: "/" }),
});

export default function Login() {
  const onClick = useServer(
    server(withRC((rc) => login(rc, "admin@example.com", "d1r3ctu5")))
  );

  return (
    <main class="text-center mx-auto text-gray-700 p-4">
      <h1 class="max-6-xs text-6xl text-sky-700 font-thin uppercase my-16">
        Login Form
      </h1>

      <div>Here shall be a login form</div>

      <button class="btn" onClick={onClick}>
        Login and navigate
      </button>
    </main>
  );
}

/*
  const [item] = createUrqlResource(function() {
    console.log('requested')

    return gql`
    query HelloWorld {
      hello
    }`
  })
  */
